<?php

namespace Drupal\simple_message\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\EntityChangedInterface;
use Drupal\Core\Entity\EntityPublishedInterface;
use Drupal\user\EntityOwnerInterface;

/**
 * Provides an interface for defining Message entities.
 *
 * @ingroup simple_message
 */
interface MessageInterface extends ContentEntityInterface, EntityChangedInterface, EntityPublishedInterface, EntityOwnerInterface {

  const TYPE_SENT = 'sent';
  const TYPE_REMOVED_ONCE = 'removed_once';
  const TYPE_REMOVED_TWICE = 'removed_twice';
  const TYPE_READ = 'read';
  const TYPE_RECEIVED = 'received';

  /**
   * Gets the Message creation timestamp.
   *
   * @return int
   *   Creation timestamp of the Message.
   */
  public function getCreatedTime();

  /**
   * Sets the Message creation timestamp.
   *
   * @param int $timestamp
   *   The Message creation timestamp.
   *
   * @return \Drupal\simple_message\Entity\MessageInterface
   *   The called Message entity.
   */
  public function setCreatedTime($timestamp);

}
