<?php

namespace Drupal\simple_message\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Form controller for Message edit forms.
 *
 * @ingroup simple_message
 */
class MessageForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    /* @var \Drupal\simple_message\Entity\Message $entity */
    $form = parent::buildForm($form, $form_state);
    $receiver = $form_state->getFormObject()->getEntity();
    $form_state->setRedirect('simple_message.threadwindow', ['sender' => $receiver->get('sender_user')->target_id]);
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    $entity = $this->entity;
    $status = parent::save($form, $form_state);
    switch ($status) {
      case SAVED_NEW:
        $this->messenger()->addMessage($this->t('Message sent'));
        break;
      default:
        $this->messenger()->addMessage($this->t('Message saved'));
    }
    $form_state->setRedirect('entity.simple_message.canonical', ['simple_message' => $entity->id()]);
  }

}
