<?php

namespace Drupal\simple_message\Plugin\Menu;

use Drupal\Component\Plugin\Derivative\DeriverBase;
use Drupal\Core\Menu\MenuLinkDefault;
use Drupal\Core\Menu\StaticMenuLinkOverridesInterface;
use Drupal\Core\Plugin\ContainerFactoryPluginInterface;
use Drupal\Core\Plugin\Discovery\ContainerDeriverInterface;
use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\simple_message\Entity\MessageInterface;
use Drupal\simple_message\MessageApi;
use Psr\Container\ContainerInterface;

/**
 * Test derivative with an unsafe string.
 */
class MessageMenuLink extends MenuLinkDefault {
use StringTranslationTrait;

  /**
   * @var MessageApi
   */
  protected $simpleMessageApi;

  /**
   * {@inheritdoc}
   */
  public function __construct($configuration, $plugin_id, $plugin_definition, $static_override, MessageApi $simpleMessageApi) {
    parent::__construct($configuration, $plugin_id, $plugin_definition, $static_override);
    $this->simpleMessageApi = $simpleMessageApi;
  }

  /**
   * {@inheritdoc}
   */
  public static function create(\Symfony\Component\DependencyInjection\ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition)
  {
    return new static(
      $configuration,
      $plugin_id,
      $plugin_definition,
      $container->get('menu_link.static.overrides'),
      $container->get('simple_message.message_api')
    );
  }

  /**
   * {@inheritdoc}
   */
  public function getTitle()
  {
    $count = $this->simpleMessageApi->getUserMessageCountPerStatus(\Drupal::currentUser(), MessageInterface::TYPE_SENT);
    if ($count == 0){
      return $this->t("Messages");
    }
    if ($count > 99) {
      $count = '99+';
    }
    return $this->t("Messages <span class='badge bg-danger small rounded-circle'>%count</span>", ['%count' => $count]);
  }


}
